!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!! Reading COSMO Topography Binary Data (0.005 deg. = 500 m data)   !!!
!!! Last Updated: March 15, 2022 (DBS/RS).                           !!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	Parameter (nxc = 21, nyc = 21, nxp = 336, nyp = 336)
	Parameter (nxnyc = nxc*nyc, nxnyp = nxp*nyp)
	!!! nxc, nyc = COSMO Grid Points
	!!! nxp, nyp = PALM Grid Points

	Real, Dimension(nxc,nyc)	:: ztopo_cosmo, clat, clon
	Real, Dimension(nxp,nyp)	:: ztopo_palm, plat, plon
	Real, Dimension(nxnyc)		:: ztopoc
	Real, Dimension(nxnyp)		:: ztopop

	Open (11, file = 'cosmo-topo.bin', form='unformatted', access='stream')
	Open (12, file = 'cosmo-topo.dat', form='formatted')
	Open (13, file = 'palm-topo.dat', form='formatted')
	Open (14, file = 'COSMO-XY.dat', form='formatted')
	Open (15, file = 'PALM-XY.dat', form='formatted')

	Open (21, file = 'COSMO-Topography.grb', form='unformatted', &
                  access='stream')
	Open (22, file = 'PALM-Topography.grb', form='unformatted',  &
                  access='stream')

	Write (14, 50) 'LON', 'LAT', 'ALT'
	Write (15, 50) 'LON', 'LAT', 'ALT'
 50	Format (3(1x, a12))

	Read (11) ztopoc

	dxc = 0.1/float(nxc-1)
	dyc = 0.1/float(nyc-1)

	dxp = 0.1/float(nxp-1)
	dyp = 0.1/float(nyp-1)

	Do jyc = 1, nyc
	Do ixc = 1, nxc
	kc = ixc + ((jyc-1)*nyc)
	clon(ixc,jyc) = 76.95 + ((ixc-1)*dxc) !- 0.0025
	clat(ixc,jyc) =  8.45 + ((jyc-1)*dyc) !- 0.0025
	ztopo_cosmo(ixc,jyc) = ztopoc(kc)
	Enddo
	Enddo

	Do ixp = 1, nxp
	Do jyp = 1, nyp
	kp = ixp + ((jyp-1)*nyp)
	plon(ixp,jyp) = 76.95 + ((ixp-1)*dxp)
	plat(ixp,jyp) =  8.45 + ((jyp-1)*dyp)
	ixc = (((ixp-1)*dxp)/dxc)+1
	jyc = (((jyp-1)*dyp)/dyc)+1
	ztopo_palm(ixp,jyp) = ztopo_cosmo(ixc,jyc)
	ztopop(kp) = ztopo_palm(ixp,jyp)	
	Enddo
	Enddo

	Do jyc = nyc, 1, -1
	Write (12, 10) (ztopo_cosmo(ixc,jyc),ixc=1,nxc)
 10	Format (21(1x, f6.1))
	Enddo

	Do jyp = nyp, 1, -1
	Write (13, 11) (ztopo_palm(ixp,jyp),ixp=1,nxp)
 11	Format (336(1x, f6.1))
	Enddo

	Do iyc = 1, nyc
	Do ixc = 1, nxc
	Write (14, 12) clon(ixc,iyc), clat(ixc,iyc), ztopo_cosmo(ixc,iyc)
 12	Format (2(1x, f12.5), 1x, f12.4)
	Enddo
	Write (14, *)
	Enddo

	Do iyp = 1, nyp
	Do ixp = 1, nxp
	Write (15, 13) plon(ixp,iyp), plat(ixp,iyp), ztopo_palm(ixp,iyp)
 13	Format (2(1x, f12.5), 1x, f12.4)
	Enddo
	Write (15, *)
	Enddo

	Write (21) ztopoc 
	Write (22) ztopop 

	Stop

	End
